cordova.define("com.whr.plugins.smartlink.WhrSmartLink", function(require, exports, module) {
var exec = cordova.require('cordova/exec');

var WHRPLUGIN_MODULE_NAME = "WhrSmartLink";


function WhrSmartLink(){
	
}
/**
下载
*/
WhrSmartLink.prototype.download = function ($url,$filepath,$filename,$success, $error) {
    exec($success, $error, WHRPLUGIN_MODULE_NAME, 'download', [$url,$filepath,$filename]);
};

/**
 * 分析二维码，调用不同的处理程序
 * 
 * @param  {[type]} $qrcode [description]
 * @return {[type]}         [description]
 */
WhrSmartLink.prototype.analysisQrcode=function($url,$code,$needProductDetail,$success,$error){
	exec($success, $error, WHRPLUGIN_MODULE_NAME, 'analysisQrcode', [$url,$code,$needProductDetail?"true":"false"]);
};
/**
 * 更换热点
 */
WhrSmartLink.prototype.changeWifi=function($ssid,$pwd,$success,$error){
    exec($success,$error,WHRPLUGIN_MODULE_NAME,'changeWifi',[$ssid,$pwd]);
};
WhrSmartLink.prototype.findWhrAp=function($ssid,$success,$error){
    exec($success,$error,WHRPLUGIN_MODULE_NAME,'findWhrAp',[$ssid]);
};
WhrSmartLink.prototype.findWhrBluetooth=function($ssid,$success,$error){
    exec($success,$error,WHRPLUGIN_MODULE_NAME,'findWhrBluetooth',[$ssid]);
};
WhrSmartLink.prototype.isConnectBluetooth=function($bluetoothName,$success,$error){
    exec($success,$error,WHRPLUGIN_MODULE_NAME,'isConnectBluetooth',[$bluetoothName]);
};
WhrSmartLink.prototype.connectBluetooth=function($mac,$ssid,$pwd,$configType,$latitude,$longitude,$info_url,$control_server,$authorization,$modelId,$brandId,$success,$error){
    exec($success,$error,WHRPLUGIN_MODULE_NAME,'connectBluetooth',[$mac,$ssid,$pwd,$configType,$latitude,$longitude,$info_url,$control_server,$authorization,$modelId,$brandId]);
};
WhrSmartLink.prototype.bluetoothDoneHook = 'bluetoothDone';
WhrSmartLink.prototype.bluetoothDone=function(result){
    var evReceive = document.createEvent('Events');
    evReceive.initEvent("bluetoothDone", true, true);
    evReceive.metadata = {
        result:result
    };
    document.dispatchEvent(evReceive);
};


/**
启动热点 配网
*/
WhrSmartLink.prototype.whrAp = function ($ssid,$pwd,$control_server,$authorization,$modelId,$brandId,$infoUrl,$success, $error) {
    exec($success, $error, WHRPLUGIN_MODULE_NAME, 'whrAp', [$ssid,$pwd,$control_server,$authorization,$modelId,$brandId,$infoUrl]);
};
/**
启动热点 配网
*/
WhrSmartLink.prototype.bind = function ($mac,$info_url,$authorization,$modelId,$latitude,$longitude,$brandId,$success, $error) {
    exec($success, $error, WHRPLUGIN_MODULE_NAME, 'bind', [$mac,$info_url,$authorization,$modelId,$latitude,$longitude,$brandId]);    
};
/**上载硬件信息，完成绑定*/
WhrSmartLink.prototype.uploadPcbInfo=function ($mac,$info_url,$authorization,$pcbPlatformId,$pcbPlatformModelHigh,$pcbPlatformModelLow,$pcbPlatformModelVersion,$success, $error) {
    exec($success, $error, WHRPLUGIN_MODULE_NAME, 'uploadPcbInfo', [$mac,$info_url,$authorization,$pcbPlatformId,$pcbPlatformModelHigh,$pcbPlatformModelLow,$pcbPlatformModelVersion]);
};

/**加载设备列表*/
WhrSmartLink.prototype.getlistAndUpdate=function($info_url,$onlyConfirmRemove,$brandId,$authorization,$success, $error){
	exec($success, $error, WHRPLUGIN_MODULE_NAME, 'getlistAndUpdate', [$info_url,$onlyConfirmRemove,$brandId,$authorization]);
};


//以下是gmt插件
var GMTONESHOT_MODULE_NAME = WHRPLUGIN_MODULE_NAME;//"GMTOneShot";
var EXEC_GET_SSID = "getSSID";
var EXEC_START_CONFIG = "startConfig";
var EXEC_STOP_CONFIG = "stopConfig";
var CONFIG_TYPE_GROUP = "group_broadcast";
var EXEC_ENABLE_ALI_LOG="enableAliLog";

WhrSmartLink.prototype.getSSID = function(success, error) {
    exec(success, error, GMTONESHOT_MODULE_NAME, EXEC_GET_SSID, []);
};
WhrSmartLink.prototype.is5G = function(success, error) {
    exec(success, error, GMTONESHOT_MODULE_NAME, 'is5G', []);
};
WhrSmartLink.prototype.receive = function(mac,ip) {
    var evReceive = document.createEvent('Events');
    evReceive.initEvent("udpReceive", true, true);
    evReceive.metadata = {
        mac:mac,
        ip:ip
    };
    document.dispatchEvent(evReceive);
};

WhrSmartLink.prototype.onekeyDoneHook = 'onekeyDone';
WhrSmartLink.prototype.onekeyDone=function(result){
    var evReceive = document.createEvent('Events');
    evReceive.initEvent("onekeyDone", true, true);
    evReceive.metadata = {
        result:result
    };
    document.dispatchEvent(evReceive);
};

/**
 * 开始配对
 * @param $onDeviceDiscover
 * @param $success
 * @param $error
 */
WhrSmartLink.prototype.startConfig = function($ssid, $password, $configType,$config, $success, $error){
    var _e = this;
    $configType = ($configType) ? $configType : CONFIG_TYPE_GROUP;
    $success = ($success) ? $success : function(){
        console.info(Date(),"startConfig ok...");
    }
    $error = ($error) ? $error : function($errMsg){
        console.info(Date(),"startConfig err:" + $errMsg);
    }
	/*
    var _$success = function(){
        console.info(Date(),"success inner startConfig...");
        $success();
    }
	*/
    exec($success, $error, GMTONESHOT_MODULE_NAME, EXEC_START_CONFIG, [$ssid, $password, $configType,$config.latitude,$config.longitude,$config.info_url,$config.control_url,$config.authorization,$config.modelId,$config.brandId]);
};

/**
 * 结束配对
 * @param $bStopCmdListener
 * @param $success
 * @param $error
 */
WhrSmartLink.prototype.stopConfig = function($success, $error){
    exec($success, $error, GMTONESHOT_MODULE_NAME, EXEC_STOP_CONFIG, []);
};
/**
 * 
 * @param {*} $userId 
 * @param {*} $authorization 
 * @param {*} $enable 是否启用
 * @param {*} $success 
 * @param {*} $error 
 */
WhrSmartLink.prototype.enableAliLog=function($userId,$authorization,$enable, $success,$error){
    exec($success,$error, GMTONESHOT_MODULE_NAME,EXEC_ENABLE_ALI_LOG,[$userId,$authorization,$enable] );
}
module.exports = new WhrSmartLink();

});
