cordova.define("com.whr.plugins.socket.Socket", function(require, exports, module) {
/* global module, require, document */
var exec = require('cordova/exec');

//
function Socket(){
    'use strict';

    this.receiveHookName = 'SOCKET_RECEIVE_DATA_HOOK';      // *** Event name to act as "hook" for data receiving
    this.connectHookName = 'SOCKET_CONNECT_HOOK';
    this.cantconnectHookName = 'SOCKET_CANTCONNECT_HOOK';
    this.pluginRef = 'Socket';                              // *** Plugin reference for Cordova.exec calls
    this.neverReconnectHookName = 'SOCKET_NEVERRECONNECT_HOOK';
    this.closedHookName = 'SOCKET_CLOSED_HOOK';
}

//
Socket.prototype.connect = function (successCallback, errorCallback,user_id, authorization,  host, port, hasHead, hasNewline, hearbeat_str, hearbeat_arr,control_enable_ssl,ssl_jks_path) {
    'use strict';
    exec(successCallback, errorCallback, this.pluginRef, 'connect', [user_id, authorization,  host, port, hasHead, hasNewline, hearbeat_str, hearbeat_arr,control_enable_ssl,ssl_jks_path]);
};

//
Socket.prototype.disconnect = function (successCallback, errorCallback, connectionId) {
    'use strict';
    exec(successCallback, errorCallback, this.pluginRef, 'disconnect', [connectionId]);
};

//
Socket.prototype.disconnectAll = function (successCallback, errorCallback) {
    'use strict';
    exec(successCallback, errorCallback, this.pluginRef, 'disconnectAll', []);
};

//
Socket.prototype.sendBlankQuery = function (connectionId,successCallback, errorCallback) {
    'use strict';
    exec(successCallback, errorCallback, this.pluginRef, 'sendBlankQuery', [connectionId]);
};
//
Socket.prototype.isConnected = function (connectionId, successCallback, errorCallback) {
    'use strict';
    exec(successCallback, errorCallback, this.pluginRef, 'isConnected', [connectionId]);
}

//
Socket.prototype.send = function (successCallback, errorCallback, connectionId, data) {
    'use strict';
    exec(successCallback, errorCallback, this.pluginRef, 'send', [connectionId, typeof data == 'string' ? data : JSON.stringify(data)]);
};

Socket.prototype.encryptAndSendBinary = function (successCallback, errorCallback, connectionId, data) {
    'use strict';
    exec(successCallback, errorCallback, this.pluginRef, 'encryptAndSendBinary', [connectionId, data.type, data.user_id,data.target, data.accessKey,data.accessIv, data.data]);
};
/**
 * 向NettyClient同步多条机型信息
 */
Socket.prototype.insertPrdDevices=function(devicelist,successCallback,errorCallback){
    exec(successCallback,errorCallback,this.pluginRef,'insertPrdDevices',[devicelist]);
}
///
Socket.prototype.sendBinary = function (successCallback, errorCallback, connectionId, data) {
    'use strict';
    exec(successCallback, errorCallback, this.pluginRef, 'sendBinary', [connectionId, data]);
};

//
Socket.prototype.receive = function (host, port, connectionId, chunk) {
    'use strict';

    var evReceive = document.createEvent('Events');

    evReceive.initEvent(this.receiveHookName, true, true);
    evReceive.metadata = {
        connection: {
            id: connectionId,
            host: host,
            port: port
        },
        data: chunk
    };

    document.dispatchEvent(evReceive);
};

Socket.prototype.dispatchConnect = function (connectionId) {
    'use strict';

    var evReceive = document.createEvent('Events');

    evReceive.initEvent(this.connectHookName, true, true);
    evReceive.metadata = {
        id: connectionId
    };

    document.dispatchEvent(evReceive);
};

Socket.prototype.dispatchCantconnect = function () {
    'use strict';

    var evReceive = document.createEvent('Events');

    evReceive.initEvent(this.cantconnectHookName, true, true);
    evReceive.metadata = {
        
    };

    document.dispatchEvent(evReceive);
};
Socket.prototype.dispatchClosed = function (connectionId) {
    'use strict';

    var evReceive = document.createEvent('Events');

    evReceive.initEvent(this.closedHookName, true, true);
    evReceive.metadata = {
        id: connectionId
    };

    document.dispatchEvent(evReceive);
};
Socket.prototype.dispatchNeverReconnect = function () {
    'use strict';

    var evReceive = document.createEvent('Events');

    evReceive.initEvent(this.neverReconnectHookName, true, true);
    evReceive.metadata = {

    };

    document.dispatchEvent(evReceive);
};
module.exports = new Socket();
});
